param(
    [Parameter(Mandatory=$true)][string]$Architecture
)

$ProgramFilesDir = (${env:ProgramFiles(x86)}, ${env:ProgramFiles} -ne $null)[0]
$VarsScriptPath = $ProgramFilesDir + "\Microsoft Visual Studio\2022\BuildTools\VC\Auxiliary\Build\vcvarsall.bat"

if (-not (Test-Path $VarsScriptPath)) {
    throw "vcvarsall.bat not found at $VarsScriptPath"
}

$TempFilePath = [IO.Path]::GetTempFileName()
cmd.exe /c "call `"$VarsScriptPath`" $Architecture && set " > $TempFilePath

Get-Content $TempFilePath | Foreach-Object {
    if ($_ -match "^(.*?)=(.*)$") {
        Set-Content "env:\$($matches[1])" $matches[2]
    }
}

Remove-Item $TempFilePath